package org.fouram.entity;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import org.apache.ibatis.type.Alias;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 *	垃圾数据更新为删除2
 *	离职数据更新为删除1，无效
 *	其他result类型数据0
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Alias(value = "SapUser")
public class SapUser implements Serializable {
	private static final long serialVersionUID = 1L;

	private String userId;
	private String personId;
	private String avatar;

	@ApiModelProperty(value = "邮箱")
	private String username;
	
	@ApiModelProperty(value = "姓名")
	private String name;

	// sap机构
	private String firstOrgId;
	private String secondOrgId;
	private String thirdOrgId;
	private String fourthOrgId;
	private String firstOrgName;
	private String secondOrgName;
	private String thirdOrgName;
	private String fourthOrgName;

	// sap职位
	private String position;
	private String formatPosition;
	// 手机
	private String mobile;
	private String formatMobile;
	// 座机
	private String businessPhone;
	private String formatBusinessPhone;
	private String gender;
	private String email;
	private String formatEmail;
	private Boolean isPrimary;
	private String result;
	private Integer delFlag;
	private Date createDate;
	private Integer sortNumber;
	
	@ApiModelProperty(value = "敏感数据sap职位")
	private String sapPosition;
	
	@ApiModelProperty(value = "敏感数据微信职位")
	private String wxPosition;
	
	@ApiModelProperty(value = "敏感数据sap部门")
	private String sapFullDepart;
	
	@ApiModelProperty(value = "敏感数据微信部门")
	private String wxFullDepart;

	private List<List<SapOrg>> departList;

	public String getFullOrgName() {
		StringBuffer sb = new StringBuffer(firstOrgName);
		if (secondOrgName != null) {
			sb.append("/").append(secondOrgName);
		}
		if (thirdOrgName != null) {
			sb.append("/").append(thirdOrgName);
		}
		if (fourthOrgName != null) {
			sb.append("/").append(fourthOrgName);
		}
		return sb.toString();
	}

	@Override
	public String toString() {
		StringBuilder sBuilder = new StringBuilder();
		sBuilder.append(userId).append(personId).append(name).append(firstOrgName).append(firstOrgId)
				.append(secondOrgName).append(secondOrgId).append(thirdOrgName).append(thirdOrgId).append(fourthOrgName)
				.append(fourthOrgId).append(position).append(mobile).append(businessPhone).append(gender).append(email)
				.append(isPrimary);
		return sBuilder.toString();
	}
}
